import java.awt.*;

public class DrawingDecks implements IDrawingDecks {
    private DecksCount deckCount;
    private Color color;

    public DrawingDecks(int decksCount, Color bodyColor) {
        setDecksCount(decksCount);
        color = bodyColor;
    }

    public void setDecksCount(int num) {
        if (num <= 1) {
            deckCount = DecksCount.One;
        } else if (num >= 3) {
            deckCount = DecksCount.Three;
        }
        else {
            deckCount = DecksCount.Two;
        }
    }

    public void draw(Graphics2D g, int x, int y, int shipWidth, int shipHeight) {
        g.setColor(color != null ? color : Color.BLACK);
        switch (deckCount) {
            case Two: {
                g.fillRect(x, y + 5, 15, 5);
                g.fillPolygon(new int[] {x, x, x + 5}, new int[] {y + 5, y + 10, y + 10}, 3);
            }
            case Three: {
                g.fillRect(x + shipWidth - 20, y, 20, 10);
                g.fillPolygon(new int[] {x + shipWidth - 20, x + shipWidth - 20, x + shipWidth - 25}, new int[] {y, y + 10, y + 10}, 3);
            }
        }
    }
}