import java.awt.*;

public class DrawingMotorShip extends DrawingShip {
    public DrawingMotorShip(int speed, float weight, Color bodyColor, int decksCount, Color dopColor, boolean pipes, boolean fueltank) {
        super(speed, weight, bodyColor, decksCount, 80, 50);
        ship = new EntityMotorShip(speed, weight, bodyColor, dopColor, pipes, fueltank);
    }

    public DrawingMotorShip(EntityMotorShip entity, IDrawingDecks decks) {
        super(entity, decks);
    }

    @Override
    public void drawTransport(Graphics2D g) {
        if (!(ship instanceof EntityMotorShip motorShip)) {
            return;
        }

        g.setColor(motorShip.getDopColor());
        g.setStroke(new BasicStroke(6));
        if (motorShip.getPipes()) {
            g.fillRect((int)_startPosX + 20, (int)_startPosY - 5, 5, 20);
            g.fillRect((int)_startPosX + 30, (int)_startPosY - 10, 5, 25);
            g.fillRect((int)_startPosX + 40, (int)_startPosY - 5, 5, 20);
        }

        g.setColor(motorShip.getBodyColor());
        super.drawTransport(g);
        g.setColor(motorShip.getDopColor());
        if (motorShip.getFuelTank()) {
            g.fillOval((int)_startPosX + 30, (int)_startPosY + 20, 25, 10);
        }
    }
}